View Javadoc

    1   /*
    2    * Copyright 2012 The Netty Project
    3    *
    4    * The Netty Project licenses this file to you under the Apache License,
    5    * version 2.0 (the "License"); you may not use this file except in compliance
    6    * with the License. You may obtain a copy of the License at:
    7    *
    8    *   http://www.apache.org/licenses/LICENSE-2.0
    9    *
    10   * Unless required by applicable law or agreed to in writing, software
    11   * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
    12   * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
    13   * License for the specific language governing permissions and limitations
    14   * under the License.
    15   */
    16  package org.jboss.netty.util;
    17
    18  import java.util.Set;
    19  import java.util.concurrent.TimeUnit;
    20
    21  /**
    22   * Schedules {@link TimerTask}s for one-time future execution in a background
    23   * thread.
    24   * @apiviz.landmark
    25   * @apiviz.has org.jboss.netty.util.TimerTask oneway - - executes
    26   * @apiviz.has org.jboss.netty.util.Timeout oneway - - creates
    27   */
    28  public interface Timer {
    29
    30      /**
    31       * Schedules the specified {@link TimerTask} for one-time execution after
    32       * the specified delay.
    33       *
    34       * @return a handle which is associated with the specified task
    35       *
    36       * @throws IllegalStateException if this timer has been
    37       *                               {@linkplain #stop() stopped} already
    38       */
    39      Timeout newTimeout(TimerTask task, long delay, TimeUnit unit);
    40
    41      /**
    42       * Releases all resources acquired by this {@link Timer} and cancels all
    43       * tasks which were scheduled but not executed yet.
    44       *
    45       * @return the handles associated with the tasks which were canceled by
    46       *         this method
    47       */
    48      Set<Timeout> stop();
    49  }